From fcd8f463a0fbba06ee1e3b06d017e5a8b0fcc6a2 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Aug 29 2020 19:13:52 +0000
Subject: [PATCH 719/2232] Data structure for source file


---

diff --git a/gen/src/file.rs b/gen/src/file.rs
new file mode 100644
index 0000000..3b45fe7
--- /dev/null
+++ b/gen/src/file.rs
@@ -0,0 +1,20 @@
+use syn::parse::{Parse, ParseStream, Result};
+use syn::{Attribute, Item};
+
+pub struct File {
+    pub attrs: Vec<Attribute>,
+    pub items: Vec<Item>,
+}
+
+impl Parse for File {
+    fn parse(input: ParseStream) -> Result<Self> {
+        let attrs = input.call(Attribute::parse_inner)?;
+
+        let mut items = Vec::new();
+        while !input.is_empty() {
+            items.push(input.parse()?);
+        }
+
+        Ok(File { attrs, items })
+    }
+}
diff --git a/gen/src/find.rs b/gen/src/find.rs
index d897deb..d4608c8 100644
--- a/gen/src/find.rs
+++ b/gen/src/find.rs
@@ -1,6 +1,6 @@
-use crate::gen::{Error, Input, Result};
+use crate::gen::{Error, File, Input, Result};
 use crate::syntax::namespace::Namespace;
-use syn::{Attribute, File, Item};
+use syn::{Attribute, Item};
 
 pub(super) fn find_bridge_mod(syntax: File) -> Result<Input> {
     match scan(syntax.items)? {
diff --git a/gen/src/mod.rs b/gen/src/mod.rs
index 710bca2..8df3404 100644
--- a/gen/src/mod.rs
+++ b/gen/src/mod.rs
@@ -2,6 +2,7 @@
 // the cxxbridge CLI command.
 
 mod error;
+mod file;
 mod find;
 pub(super) mod include;
 pub(super) mod out;
@@ -11,6 +12,7 @@ mod write;
 mod tests;
 
 use self::error::{format_err, Error, Result};
+use self::file::File;
 use crate::syntax::namespace::Namespace;
 use crate::syntax::report::Errors;
 use crate::syntax::{self, check, Types};
@@ -56,7 +58,7 @@ fn generate_from_path(path: &Path, opt: Opt, header: bool) -> Vec<u8> {
 fn generate(source: &str, opt: Opt, header: bool) -> Result<Vec<u8>> {
     proc_macro2::fallback::force();
     let ref mut errors = Errors::new();
-    let syntax = syn::parse_file(&source)?;
+    let syntax: File = syn::parse_str(source)?;
     let bridge = find::find_bridge_mod(syntax)?;
     let ref namespace = bridge.namespace;
     let ref apis = syntax::parse_items(errors, bridge.module);

